/// <reference types="node" />
import { EventEmitter } from "events";
import { Config, Test, CreeveyStatus, ApprovePayload } from "../../types";
export default class Runner extends EventEmitter {
    private screenDir;
    private reportDir;
    tests: Partial<{
        [id: string]: Test;
    }>;
    private browsers;
    private pools;
    readonly isRunning: boolean;
    constructor(config: Config);
    private handlePoolMessage;
    private handlePoolStop;
    init(): Promise<Partial<{
        [id: string]: Test;
    }>>;
    start(ids: string[]): void;
    stop(): void;
    readonly status: CreeveyStatus;
    approve({ id, retry, image }: ApprovePayload): Promise<void>;
    private sendUpdate;
}
